/*
 * Eufruncio - El gusanito comefichas
 * Copyright (C) 2003-2004 Sebastin Galiano, Milton Pividori, Csar Sandrigo
 * 
 * This file is part of Eufruncio.
 * 
 * Eufruncio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Eufruncio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Eufruncio; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/************************************************************************************************
  Definimos los tipos que utilizaremos en este archivo
************************************************************************************************/

/* Tipo que representa las opciones del men */
typedef enum MenuOpciones {NINGUNA, JUGAR, OPCIONES, CREDITOS, SALIR} opciones;

/* Tipo que representa las opciones del men */
typedef struct lista_doble_enlazada
{
  opciones id;
  int color, fondo;
  struct lista_doble_enlazada *sig, *ant;
} menu;



/************************************************************************************************
  Agrega un nuevo nodo de la lista de opciones
************************************************************************************************/

menu *NuevaOpcion()
{
  menu *p;
  p = (menu *)malloc(sizeof(menu));

  return p;
}



/************************************************************************************************
  Muestra el marco que encierra las opciones
************************************************************************************************/

void DibujarMarco(char Titulo[])
{
 
  /* Dibujamos el marco */
  textcolor(MAGENTA); textbackground(COLORDIALOGOS); 
  Centrar(4, "                          Ŀ");
  Centrar(5, "                                                ");
  Centrar(6, "                                                ");
  Centrar(7, "                                                ");
  Centrar(8, "                                                ");
  Centrar(9, "                                                ");
  Centrar(10, "                                                ");
  Centrar(11, "                                                ");
  Centrar(12, "                                                ");
  Centrar(13, "                                                ");
  Centrar(14, "                                                ");
  Centrar(15, "                                                ");
  Centrar(16, "                                                ");
  Centrar(17, "                                                ");
  Centrar(18, "                                                ");
  Centrar(19, "                                                ");
  Centrar(20, "                                                ");
  Centrar(21, "                                                ");
  Centrar(22, "                                                ");
  Centrar(23, "                                                ");
  Centrar(24, "                                                ");
  Centrar(25, "                                                ");
  Centrar(26, "                                                ");
  Centrar(27, "                                                ");
  Centrar(28, "                                                ");
  Centrar(29, "                                                ");
  Centrar(30, "");

  /* Escribimos el ttulo */
  textcolor(BLUE); textbackground(MAGENTA);
  Centrar(3, "                          ");
  Centrar(4, "                        "); Centrar(4, Titulo);
  Centrar(5, "                          ");
  
}



/************************************************************************************************
  Muestra las opciones en pantalla
************************************************************************************************/

void MostrarOpciones(menu *aux1)
{
  /* Mostramos las opciones en pantalla */
  char Texto[18], Fila=9; menu *aux2=aux1;  

  do
  {
    /* Le damos el texto correspondiente a la opcin*/
    switch(aux2->id)
    {
      case JUGAR:
        strcpy(Texto, "       JUGAR      "); break;
      case OPCIONES:
        strcpy(Texto, "     OPCIONES     "); break;
      case CREDITOS:
        strcpy(Texto, "     CREDITOS     "); break;
      case SALIR:
        strcpy(Texto, "       SALIR      "); break;
      case 5:
	    strcpy(Texto, "       Fcil      "); break;
      case 6:
        strcpy(Texto, "       Media      "); break;
      case 7:
	    strcpy(Texto, "      Difcil     "); break;
      case 8:
	    strcpy(Texto, "    Muy Difcil   "); break;
        }

    /* Imprimimos cada opcin */
    textbackground(aux2->fondo); textcolor(aux2->color);
    Centrar(Fila+1, "                    ");
    Centrar(Fila, Texto);
    Centrar(Fila-1, "                    ");
    Fila+=6;
    aux2=aux2->sig;

  } while (aux2 != aux1);

}




/************************************************************************************************
  Muestra el men de opciones del juego
************************************************************************************************/

/* El men y sus opciones estn implementados en un lista doblemente enlazada */
opciones VisualizarMenu(void)
{
  /* Declaramos variables auxiliares */
  char Tecla, Fila=6; boolean Termina=FALSE;
  opciones Valor;

  /* Opciones del men */
  menu *jugar, *opciones, *creditos, *salir, *aux;

  /* Inicializamos la opcin de jugar como la por defecto */
  jugar = NuevaOpcion();
  jugar->id = JUGAR;
  jugar->color=COLORTEXTOMENURESALTADO;
  jugar->fondo=COLORRESALTEMENU;

  /* Inicializamos la opcin de configuracion del juego */
  opciones = NuevaOpcion();
  opciones->id = OPCIONES;
  opciones->color=COLORTEXTOMENUNORMAL;
  opciones->fondo=COLORNORMALMENU;

  /* Inicializamos la opcin de acerca del juego */
  creditos = NuevaOpcion();
  creditos->id = CREDITOS;
  creditos->color=COLORTEXTOMENUNORMAL;
  creditos->fondo=COLORNORMALMENU;

  /* Inicializamos la opcin de salir */
  salir = NuevaOpcion();
  salir->id = SALIR;
  salir->color = COLORTEXTOMENUNORMAL;
  salir->fondo=COLORNORMALMENU;

  /* Enlazamos la lista */
  jugar->ant=salir;
  jugar->sig=opciones;

  opciones->ant=jugar;
  opciones->sig=creditos;

  creditos->ant=opciones;
  creditos->sig=salir;

  salir->ant=creditos;
  salir->sig=jugar;

  /* El apuntador lo pondremos apuntando a jugar */
  aux=jugar;
  Valor=aux->id;

  /* Pintamos el fondo */
  textbackground(COLORFONDODIALOGOS); clrscr();
  
  /* Creamos una ventana de texto */
  window(2,2,79,17); textbackground(BLACK); clrscr();
  
  /* Imprimimos el ttulo */
  textcolor(GREEN);
  Centrar(Fila, "###### #    # ###### #####  #    # #    #  ####  #  #### "); Fila++;
  Centrar(Fila, "#      #    # #      #    # #    # ##   # #    # # #    #"); Fila++;
  Centrar(Fila, "#####  #    # #####  #    # #    # # #  # #      # # #  #"); Fila++;
  Centrar(Fila, "#      #    # #      #####  #    # #  # # #      # #  # #"); Fila++;
  Centrar(Fila, "#      #    # #      #   #  #    # #   ## #    # # #    #"); Fila++;
  Centrar(Fila, "######  ####  #      #    #  ####  #    #  ####  #  #### "); Fila+=2;

  /* Adornamos la ventana */
  window(1,1,80,50);
  textbackground(COLORFONDODIALOGOS); textcolor(DARKGRAY);
  gotoxy(2,2); cprintf("%c", 254); gotoxy(2,17); cprintf("%c", 254);
  gotoxy(79,2); cprintf("%c", 254); gotoxy(79,17); cprintf("%c", 254);

  /* Creamos otra ventana de texto */
  window(2,19,79,49); textbackground(COLORDIALOGOS); clrscr();

  /* Mostramos el ttulo */
  DibujarMarco("MENU PRINCIPAL");

  /* Mostramos el men de opciones */
  MostrarOpciones(jugar);

  /* Bucle que finaliza cuando se presiona Enter o Escape */
  while(!Termina)
  {
    /* Segn la tecla presionada realizamos la secuencia correspondiente */
    if (kbhit())
    {
      /* Leemos la tecla presionada */
      Tecla = getch();

      /* Salimos del juego sin confirmacin */
      if (Tecla == ESCAPE)
      {
        Valor = SALIR;
        Termina = TRUE;
      }

      /* Elegimos la opcin corresondiente */
      if (Tecla == SPACE)
      {
        sound(); delay(100); nosound();
        Termina = TRUE;
      }

      /* Leemos las teclas direccionales */
      if (!Tecla)
      {
        /* Se trata de un cdigo ASCII Extendido */
        Tecla = getch();

        /* Segn la tecla presionada realizamos lo correspondiente */
        switch (Tecla)
        {
          case TECLAARRIBA:
            /* Cambiamos los colores */
	        aux->color=COLORTEXTOMENUNORMAL;
	        aux->fondo=COLORNORMALMENU;
	        aux=aux->ant;
	        aux->color=COLORTEXTOMENURESALTADO;
	        aux->fondo=COLORRESALTEMENU;

            /* Guardamos el valor que devolveremos */
            Valor=aux->id;

            /* Actualizamos las opciones en pantalla */
            MostrarOpciones(jugar);

	        break;

          case TECLAABAJO:
            /* Cambiamos los colores */
	        aux->color=COLORTEXTOMENUNORMAL;
	        aux->fondo=COLORNORMALMENU;
 	        aux=aux->sig;
	        aux->color=COLORTEXTOMENURESALTADO;
	        aux->fondo=COLORRESALTEMENU;

            /* Guardamos el valor que devolveremos */
	        Valor=aux->id;

            /* Actualizamos las opciones en pantalla */
            MostrarOpciones(jugar);

	        break;
        }

      }

    }

  }

  /* Volvemos a la pantalla completa */
  window(1,1,80,50);

  /* Liberamos la memoria utilizada */
  free(jugar); free(opciones);
  free(creditos); free(salir);

  /* Devolvemos un valor correspondiente a la opcin elegida */
  return Valor;

}



/************************************************************************************************
  Muestra el men de dificultades del juego
************************************************************************************************/

/* El men y sus opciones estn implementados en un lista doblemente enlazada */
unsigned char VisualizarMenuDificultades(void)
{
  /* Declaramos variables auxiliares */
  char Tecla, Valor; boolean Termina=FALSE;

  /* Opciones del men de dificultades */
  menu *facil, *media, *dificil, *muydificil, *aux;

  /* Fcil */
  facil = NuevaOpcion();
  facil->id = 5;
  facil->color=COLORTEXTOMENUNORMAL;
  facil->fondo=COLORNORMALMENU;

  /* Dificultad media. Por defecto */
  media = NuevaOpcion();
  media->id = 6;
  media->color=COLORTEXTOMENURESALTADO;
  media->fondo=COLORRESALTEMENU;

  /* Difcil */
  dificil = NuevaOpcion();
  dificil->id = 7;
  dificil->color = COLORTEXTOMENUNORMAL;
  dificil->fondo=COLORNORMALMENU;
  
  /* Muy difcil */
  muydificil = NuevaOpcion();
  muydificil->id = 8;
  muydificil->color = COLORTEXTOMENUNORMAL;
  muydificil->fondo=COLORNORMALMENU;  

  /* Enlazamos la lista */
  facil->ant=muydificil;
  facil->sig=media;

  media->ant=facil;
  media->sig=dificil;

  dificil->ant=media;
  dificil->sig=muydificil;

  muydificil->ant=dificil;
  muydificil->sig=facil;

  /* El apuntador lo pondremos apuntando a media */
  aux=media;
  Valor=aux->id;
  
  /* Creamos otra ventana de texto */
  window(2,19,79,49); textbackground(COLORDIALOGOS); clrscr();

  /* Mostramos el ttulo */
  DibujarMarco("DIFICULTAD");

  /* Mostramos el men de opciones */
  MostrarOpciones(facil);

  /* Bucle que finaliza cuando se presiona Enter o Escape */
  while(!Termina)
  {
    /* Segn la tecla presionada realizamos la secuencia correspondiente */
    if (kbhit())
    {    
      /* Leemos la tecla presionada */
      Tecla = getch();
    
      /* Salimos del juego sin confirmacin */
      if (Tecla == ESCAPE)
      {
        Valor = SALIR;
        Termina = TRUE;
      }

      /* Elegimos la opcin corresondiente */
      if (Tecla == SPACE)
      {
        sound(); delay(100); nosound();
        Termina = TRUE;        
      }

      /* Leemos las teclas direccionales */
      if (!Tecla)
      {
        /* Se trata de un cdigo ASCII Extendido */
        Tecla = getch();
        
        /* Segn la tecla presionada realizamos lo correspondiente */        
        switch (Tecla)
        {
          case TECLAARRIBA:            
            /* Cambiamos los colores */
	        aux->color=COLORTEXTOMENUNORMAL;
	        aux->fondo=COLORNORMALMENU;
	        aux=aux->ant;
	        aux->color=COLORTEXTOMENURESALTADO;
	        aux->fondo=COLORRESALTEMENU;
	        
            /* Guardamos el valor que devolveremos */
            Valor=aux->id;
            
            /* Actualizamos las opciones en pantalla */
            MostrarOpciones(facil);
            
	        break; 
                
          case TECLAABAJO:	        
            /* Cambiamos los colores */	        
	        aux->color=COLORTEXTOMENUNORMAL;
	        aux->fondo=COLORNORMALMENU;
 	        aux=aux->sig;
	        aux->color=COLORTEXTOMENURESALTADO;
	        aux->fondo=COLORRESALTEMENU;
	        
            /* Guardamos el valor que devolveremos */
	        Valor=aux->id;       
	        
            /* Actualizamos las opciones en pantalla */
            MostrarOpciones(facil);     
	        
	        break;                    
        }        
      
      }
      
    }    

  }

  /* Volvemos a la pantalla completa */
  window(1,1,80,50);
  
  /* Liberamos la memoria utilizada */
  free(facil); free(media);
  free(dificil); free(muydificil);  

  /* Devolvemos un valor correspondiente a la opcin elegida */
  switch (Valor)
  {
    case 5: return 200;
    case 6: return 100;
    case 7: return 50;
    case 8: return 25;
  }        

}

