/*
 * Eufruncio - El gusanito comefichas
 * Copyright (C) 2003-2004 Sebastin Galiano, Milton Pividori, Csar Sandrigo
 * 
 * This file is part of Eufruncio.
 * 
 * Eufruncio is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Eufruncio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Eufruncio; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/************************************************************************************************
*************************************************************************************************
*************************************************************************************************

    SUPER JUEGO DEL GUSANO EUFRUNCIO

*************************************************************************************************
*************************************************************************************************
************************************************************************************************/



/************************************************************************************************
  Constantes
************************************************************************************************/

/* Dimensiones de la pantalla */
#define ANCHO 80
#define ALTO 50

/* Atributos del gusano */
#define VELOCIDADINICIAL 100
#define CRECIMIENTO 5
#define LONGITUDINICIAL 5
#define PUNTAJECOMERFICHA 800

/* Paleta de colores */
#define COLORTITULO LIGHTRED
#define COLORGUSANO CYAN
#define COLORPARED GREEN
#define COLORFONDO BLACK
#define COLORFICHA LIGHTRED
#define COLOROBSTACULO BROWN
#define COLORTEXTO DARKGRAY
#define COLORFONDOTEXTO BLACK
#define COLORDIALOGOS BLUE
#define COLORFONDODIALOGOS CYAN
#define COLORBARRAESTADO LIGHTCYAN
#define COLORTEXTOMENUNORMAL WHITE
#define COLORTEXTOMENURESALTADO YELLOW
#define COLORNORMALMENU RED
#define COLORRESALTEMENU BLACK

/* Direcciones */
#define ARRIBA 8
#define ABAJO 2
#define DERECHA 6
#define IZQUIERDA 4

/* Codigos ASCII Normales */
#define ESCAPE 27
#define SPACE 32

/* Codigos ASCII Extendidos */
#define TECLAARRIBA 72
#define TECLAABAJO 80
#define TECLADERECHA 77
#define TECLAIZQUIERDA 75



/************************************************************************************************
  Declaraciones de archivos de cabecera
************************************************************************************************/

#include <conio.h>
/*#include <ctype.h>*/
/*#include <stdlib.h>*/
#include <stdio.h>
/*#include <string.h>*/
/*#include <dos.h>*/



/************************************************************************************************
  Definimos los tipos que utilizaremos
************************************************************************************************/

/* Simulamos el tipo booleano */
typedef enum tipoBoolean {FALSE, TRUE} boolean;

/* Estructura que almacena datos sobre el gusano */
typedef struct tipoGusano
{
  unsigned short longitud; /* Largo del gusano */
  int direccion; /* Direccin a la cual est apuntando actualmente el gusano */
  long puntaje; /* Puntaje acumulado */
  unsigned short fichas_comidas;
} datos;



/************************************************************************************************
  Escribe centrado un texto en pantalla
************************************************************************************************/

void Centrar(char Fila, char Texto[])
{
  /* Variables auxiliares */
  int Columna=ANCHO/2, Len=strlen(Texto);

  /* Centramos el texto */
  if (Len<ANCHO)
    Columna-=Len/2;
  else
    Columna=1;

  /* Imprimimos el texto en la pantalla */
  gotoxy(Columna, Fila); cprintf(Texto);
}


/************************************************************************************************
  Rutina que pregunta al usuario si desea ver la repeticin del juego
************************************************************************************************/

boolean Confirmacion(char Texto[])
{ 
   /* Variables */
  char Tecla, i; boolean Repetir;

  /* Seteamos los colores */
  textcolor(COLORDIALOGOS); textbackground(COLORFONDODIALOGOS);

  /* Mostramos la ventana */
  Centrar(23, "");
  Centrar(24, "                                                ");
  Centrar(25, "                                                ");
  Centrar(26, "                                                ");
  Centrar(27, "");

  /* Mostramos el texto */
  Centrar(25, Texto);

  /* Vaciamos el buffer del teclado */
  fflush(stdin);

  /* Esperamos que se pulse una tecla */
  do {
       Tecla=getch();
       
	   switch (Tecla)
	   {
         case 's': case 'S': Repetir=FALSE; break;
		 case 'n': case 'N': Repetir=FALSE; break;
		 default: Repetir=TRUE; break;
       }
  } while (Repetir);

  /* Restauramos los colores y el fondo */
  textcolor(COLORGUSANO); textbackground(COLORFONDO);
  for(i=23; i<28; i++)
    Centrar(i, "                                                             ");

  /* Retornamos el valor correspodiente */
  if (Tecla == 's' || Tecla == 'S')
    return TRUE;
  else
    return FALSE;
}



/************************************************************************************************
  Agregamos el cdigo de los archivos siguientes que contienen definiciones de las funciones que
  utilizaremos a lo largo del juego.
************************************************************************************************/

#include "carga.c"
#include "mov.c"
#include "repetir.c"
#include "menu.c"
#include "varios.c"



/************************************************************************************************
  Rutina principal del juego
************************************************************************************************/

boolean Jugar(rep **inicio_rep, rep **fin_rep, obs *obstaculos[], ficha **fichas, unsigned char Velocidad)
{
  /* Variables relacionadas con el tablero de juego y el gusano */
  gusano *cabeza = NULL;
  ficha *aux_fichas = *fichas;

  /* Variables locales */
  
  char i, tecla, giro, termina=0, salir=0, cantidad_movimientos = 0;

  /* Declaramos la estructura que contendr datos generales sobre el gusano */
  datos Eufruncio;

  /* Inicializamos la estructura con datos del gusano */
  Eufruncio.longitud=LONGITUDINICIAL;
  Eufruncio.direccion = ARRIBA;
  Eufruncio.puntaje = 0;
  Eufruncio.fichas_comidas = 0;

  /* Inicializamos el tablero */
  textbackground(COLORFONDO); clrscr();

  /* Mostramos las paredes */
  DibujarParedes(COLORPARED);	    

  /* Mostramos el ttulo del juego */
  textcolor(COLORTITULO); Centrar(1, ">>> EUFRUNCIO, EL GUSANITO COMEFICHAS <<<");

  /* Actualizamos el puntaje y la cantidad de fichas recogidas */
  Datos(Eufruncio);

  /* Mostramos una ventana */
  textcolor(COLORDIALOGOS); textbackground(COLORFONDODIALOGOS);
  Centrar(23, "");
  Centrar(24, "                                                           ");
  Centrar(25, "    Listo para jugar. Presione una tecla para comenzar.    ");
  Centrar(26, "                                                           ");
  Centrar(27, "");

  /* Esperamos que se presione una tecla */
  tecla=getch();

  /* Borramos la ventana */
  textcolor(COLORGUSANO); textbackground(COLORFONDO);
  for(i=23; i<28; i++)
    Centrar(i, "                                                             ");

  /* Creamos el gusano en memoria y lo mostramos en pantalla */
  CrearGusano(&cabeza);

  /* Mostramos en pantalla los obstculos */
  VisualizarObstaculos(obstaculos);

  /* Ahora visualiamos la primer ficha */
  MostrarSiguienteFicha(aux_fichas, cabeza);

  /* Seteamos el color del gusano */
  textcolor(COLORGUSANO);

  /* Bucle que se ejecuta hasta que el gusano muere */
  while (!termina && !salir)
  {

    /* Retardamos la ejecucin */
    delay(Velocidad);

    /* Segn la tecla presionada realizamos la secuencia correspondiente */
    if (kbhit())
    {
      /* Leemos la tecla presionada */
      tecla = getch();

      /* Ponemos el juego en pausa */
      if (tolower(tecla) == 'p')
      {
        textcolor(RED);
        Centrar(50,"Presione una tecla para continuar jugando...");        
        do {
             textcolor(LIGHTRED);
             Centrar(49," Juego en pausa "); delay(500);
             Centrar(49,"                 "); delay(500);
        } while (!kbhit());        
        getch();
        Centrar(50,"                                            ");                       
        textcolor(COLORGUSANO);
      }

      /* Salimos del juego con confirmacin */
      if (tecla == ESCAPE)
      {
        salir = Confirmacion("Desea terminar la partida? (S/N)");
        if (!salir)
        {
          VisualizarObstaculos(obstaculos);
          VisualizarFicha(aux_fichas->columna, aux_fichas->fila);                
        }
      }	 

      /* Dirigimos al gusano */
      if (!tecla)
      {
        /* Agregamos la tecla presionada a la lista que almacena los movimientos del gusano */
        AgregarTecla(inicio_rep, fin_rep, tecla, &cantidad_movimientos);
        
        /* Por tener las teclas direccionales un cdigo ASCII Extendido*/
        tecla = getch();
        
        /* Agregamos la tecla presionada a la lista que almacena los movimientos del gusano */
        AgregarTecla(inicio_rep, fin_rep, tecla, &cantidad_movimientos);

        /* Le damos direccin al gusano */
        switch (tecla)
        {
          case TECLAARRIBA:
            if ((Eufruncio.direccion == ARRIBA) || (Eufruncio.direccion == ABAJO))
              giro = ' ';
            if (Eufruncio.direccion == IZQUIERDA)
              giro = 'd';
            else if (Eufruncio.direccion == DERECHA)
              giro = 'i';            
            break;

          case TECLAABAJO:
            if ((Eufruncio.direccion == ARRIBA) || (Eufruncio.direccion == ABAJO))
              giro = ' ';
            if (Eufruncio.direccion == IZQUIERDA)
              giro = 'i';
            else if (Eufruncio.direccion == DERECHA)
              giro = 'd';
            break;
          
          case TECLAIZQUIERDA:
          if ((Eufruncio.direccion == DERECHA) || (Eufruncio.direccion == IZQUIERDA))
            giro = ' ';
          if (Eufruncio.direccion == ARRIBA)
            giro = 'i';
          else if (Eufruncio.direccion == ABAJO)
            giro = 'd';
          break;
          
          case TECLADERECHA:
          if ((Eufruncio.direccion == DERECHA) || (Eufruncio.direccion == IZQUIERDA))
            giro = ' ';
          if (Eufruncio.direccion == ARRIBA)
            giro = 'd';
          else if (Eufruncio.direccion == ABAJO)
            giro = 'i';
          break;
        }
      }
      else
        giro = ' ';
    }
    else
      giro = ' ';
    
    /* Incrementamos el contador de los movimientos y movemos al gusano */
    cantidad_movimientos++;
    termina = MoverGusano(&cabeza, giro, &Eufruncio, obstaculos, &aux_fichas);
        
  }

  /* Mostramos en la barra de estado */
  gotoxy(1,50); textcolor(COLORPARED);
  if (termina == 1)
    Centrar(50, "Perdiste!! Nabo.....");
  else if (termina == 2)
    Centrar(50, "Felicitaciones, te morfaste todas las fichas...");
  
  /* Liberamos la memoria ocupada para almacenar el gusano */	
  LiberarGusano(&cabeza);

  /* Liberamos las fichas */
  LiberarFichas(&aux_fichas);	 		
  *fichas = aux_fichas;
	 		
  return salir;
  
}


	
/************************************************************************************************
 ************************************************************************************************
     Programa principal
 ************************************************************************************************
************************************************************************************************/

void main()
{
  /* Declaramos las variables auxiliares de la funcin principal */
  opciones Menu; char i; 
  
  /* Variables que tiene que ver con la dificultad del juego */
  unsigned char Velocidad=VELOCIDADINICIAL;

  /* Declaramos el vector de listas que almacena los obstculos */
  obs *obstaculos[45];

  /* Declaramos dos pilas idnticas que guardaran las fichas en memoria */
  ficha *fichas_jugar = NULL, *fichas_repetir = NULL;

  /* Variables que usamos para repetir la jugada */
  rep *inicio_rep = NULL;
  rep *fin_rep = NULL;

  /* Inicializamos el modo texto extendido que nos da un tablero de 80x50 */
  textmode(C4350);
       
  /* Desactivamos el cursor */
  _setcursortype(_NOCURSOR);
  
  /* Mostramos la introduccin */
  Intro();

  /* Inicializamos el tablero y el vector de listas de los obstculos */
  textcolor(COLORGUSANO); textbackground(COLORFONDO); clrscr();
  for (i=0; i<45; i++)
    obstaculos[i] = NULL;

  /* Presentamos el men de opciones en pantalla */
  Menu = VisualizarMenu();
  
  /* Realizamos la opcin elegida */
  while ( Menu != SALIR )
  {
    switch (Menu)
    {
      case JUGAR:
      {
        /* Variable que indica si se sali mediante la tecla ESCAPE o si se termin de jugar */
		boolean Salir;

       /* Cargamos en memoria los obstculos y las fichas desde el archivo */
       CargarConfiguracion(obstaculos, &fichas_jugar, &fichas_repetir);
       
       /* Jugamos hasta que choquemos con algo o hasta que se presione Escape */
       Salir = Jugar(&inicio_rep, &fin_rep, obstaculos, &fichas_jugar, Velocidad);

       /* Pregunta si se desea ver la repeticin */
       if ( !Salir && Confirmacion("Desea ver una repeticin de la jugada? (S/N)") )
         /* Si es as, repetimos la jugada y liberamos automticamente memoria */
         Repetir(&inicio_rep, &fin_rep, obstaculos, &fichas_repetir, Velocidad);
         
       /* Sino, liberamos la cola que almacena los movimientos */
       LiberarRep(&inicio_rep, &fin_rep);

       /* Liberamos la memoria usada para los obstaculos */
       LiberarObstaculos(obstaculos);
       
       /* Liberamos las fichas */
       LiberarFichas(&fichas_repetir);

       /* Vaciamos el vector de punteros que representa a los obstculos */
       for (i=0; i<45; i++)
         obstaculos[i] = NULL; 

       break;
      }

      case OPCIONES:
      {
        Velocidad = VisualizarMenuDificultades();
        break;
      }

      case CREDITOS:
      {        
        Creditos();
        break;
      }
    }

    Menu = VisualizarMenu();

  }

  /* Borramos la pantalla */
  textcolor(WHITE); textbackground(BLACK); clrscr();

}



